package com.xymc.vexonlinetime.main;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.xymc.vexonlinetime.Event.PlayerEvent;
import com.xymc.vexonlinetime.Event.VexEvent;
import com.xymc.vexonlinetime.command.PlayerCommand;
import com.xymc.vexonlinetime.model.ClickableVexButtonConfig;
import com.xymc.vexonlinetime.model.GuiConfig;
import com.xymc.vexonlinetime.model.ItemConfig;
import com.xymc.vexonlinetime.model.MessageConfig;
import com.xymc.vexonlinetime.model.PlayerTitleConfig;
import com.xymc.vexonlinetime.model.StateImgConfig;
import com.xymc.vexonlinetime.model.TimeConfig;
import com.xymc.vexonlinetime.model.TitleConfig;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import lk.vexview.gui.components.VexImage;
import lk.vexview.gui.components.VexText;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandExecutor;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.java.JavaPlugin;

public class MainPlugin extends JavaPlugin {
  public static com.xymc.vexonlinetime.main.MainPlugin plugin;
  
  public static HashMap<String, Integer> PLAYER_TIME_MAP = new HashMap<>();
  
  private static int DAY;
  
  private static int MONTH;
  
  public void onEnable() {
    System.out.println("[VexOnlineTime] 插件加载中......");
    if (!hasVV()) {
      Bukkit.getConsoleSender().sendMessage("[VexOnlineTime] §c未找到VexView插件,插件自动卸载！");
      getServer().getPluginManager().disablePlugin((Plugin)this);
      return;
    } 
    Bukkit.getConsoleSender().sendMessage("[VexOnlineTime] §a已找到VexView插件,关联成功！");
    plugin = this;
    Bukkit.getPluginCommand("xytime").setExecutor((CommandExecutor)new PlayerCommand());
    Bukkit.getPluginManager().registerEvents((Listener)new VexEvent(), (Plugin)this);
    Bukkit.getPluginManager().registerEvents((Listener)new PlayerEvent(), (Plugin)this);
    File configFile = new File(getDataFolder(), "config.yml");
    if (!configFile.exists()) {
      saveDefaultConfig();
      File playerDataFile = new File(getDataFolder(), "Data");
      playerDataFile.mkdirs();
      File itemFile = new File(getDataFolder(), "Items");
      itemFile.mkdirs();
      saveResource("message.yml", true);
    } 
    loadConfig();
    for (Player player : getServer().getOnlinePlayers()) {
      File playerDataFile = new File(new File(plugin.getDataFolder(), "Data"), player.getName() + ".yml");
      YamlConfiguration playerYml = YamlConfiguration.loadConfiguration(playerDataFile);
      PLAYER_TIME_MAP.put(player.getName(), Integer.valueOf(playerYml.getInt("time")));
      VexEvent.playerPages.put(player.getName(), Integer.valueOf(1));
    } 
    (new Object(this))





























      
      .runTaskTimerAsynchronously((Plugin)this, 0L, 1200L);
  }
  
  public void onDisable() {
    Bukkit.getConsoleSender().sendMessage("[VexOnlineTime] §e插件卸载,保存数据中...");
    for (Player player : getServer().getOnlinePlayers()) {
      File playerDataFile = new File(new File(plugin.getDataFolder(), "Data"), player.getName() + ".yml");
      YamlConfiguration playerYml = YamlConfiguration.loadConfiguration(playerDataFile);
      if (PLAYER_TIME_MAP.containsKey(player.getName())) {
        playerYml.set("time", PLAYER_TIME_MAP.get(player.getName()));
        try {
          playerYml.save(playerDataFile);
        } catch (IOException e) {
          e.printStackTrace();
        } 
      } 
    } 
    Bukkit.getConsoleSender().sendMessage("[VexOnlineTime] §e玩家数据保存完成...");
  }
  
  private boolean hasVV() {
    if (getServer().getPluginManager().getPlugin("VexView") != null)
      return true; 
    return false;
  }
  
  public static void loadConfig() {
    File file = new File(plugin.getDataFolder(), "config.yml");
    YamlConfiguration yml = YamlConfiguration.loadConfiguration(file);
    GuiConfig guiConfig = GuiConfig.getGuiConfig();
    guiConfig.setUrl(yml.getString("Gui.url"));
    guiConfig.setX(yml.getInt("Gui.x"));
    guiConfig.setY(yml.getInt("Gui.y"));
    guiConfig.setWidth(yml.getInt("Gui.width"));
    guiConfig.setHeight(yml.getInt("Gui.height"));
    guiConfig.setXshow(yml.getInt("Gui.xshow"));
    guiConfig.setYshow(yml.getInt("Gui.yshow"));
    TitleConfig titleConfig = TitleConfig.getTitleConfig();
    titleConfig.setX(yml.getInt("Title.x"));
    titleConfig.setY(yml.getInt("Title.y"));
    titleConfig.setTitle(yml.getString("Title.text"));
    PlayerTitleConfig playerTitleConfig = PlayerTitleConfig.getPlayerTitleConfig();
    playerTitleConfig.setTitle(yml.getString("PlayerTitle.text"));
    playerTitleConfig.setX(yml.getInt("PlayerTitle.x"));
    playerTitleConfig.setY(yml.getInt("PlayerTitle.y"));
    String successUrl = yml.getString("StateImage.success.url");
    int successX = yml.getInt("StateImage.success.x");
    int successY = yml.getInt("StateImage.success.y");
    int successXshow = yml.getInt("StateImage.success.xshow");
    int successYshow = yml.getInt("StateImage.success.yshow");
    StateImgConfig.setSuccessVexImage(new VexImage(successUrl, successX, successY, successXshow, successYshow));
    String failUrl = yml.getString("StateImage.fail.url");
    int failX = yml.getInt("StateImage.fail.x");
    int failY = yml.getInt("StateImage.fail.y");
    int failXshow = yml.getInt("StateImage.fail.xshow");
    int failYshow = yml.getInt("StateImage.fail.yshow");
    StateImgConfig.setFailVexImage(new VexImage(failUrl, failX, failY, failXshow, failYshow));
    int i = 1;
    for (String key : yml.getConfigurationSection("TimeList").getKeys(false)) {
      TimeConfig timeConfig = new TimeConfig();
      String timePath = "TimeList." + key;
      timeConfig.setId(key);
      timeConfig.setTitleX(yml.getInt(timePath + ".title.x"));
      timeConfig.setTitleY(yml.getInt(timePath + ".title.y"));
      timeConfig.setTitleText(yml.getString(timePath + ".title.text"));
      timeConfig.setDescX(yml.getInt(timePath + ".desc.x"));
      timeConfig.setDescY(yml.getInt(timePath + ".desc.y"));
      timeConfig.setTime(yml.getInt(timePath + ".time"));
      timeConfig.setCmdList(yml.getStringList(timePath + ".command"));
      timeConfig.setItemList(yml.getStringList(timePath + ".item"));
      timeConfig.setDescTextList(yml.getStringList(timePath + ".desc.text"));
      TimeConfig.getTimeConfigMap().put(Integer.valueOf(i), timeConfig);
      i++;
    } 
    File itemsFile = new File(plugin.getDataFolder(), "Items");
    for (String itemFileString : itemsFile.list()) {
      File itemFile = new File(itemsFile, itemFileString);
      YamlConfiguration itemYml = YamlConfiguration.loadConfiguration(itemFile);
      String itemId = itemFileString.replace(".yml", "");
      ItemConfig itemConfig = new ItemConfig();
      List<ItemStack> itemStackList = new ArrayList<>();
      for (String key : itemYml.getKeys(false))
        itemStackList.add(itemYml.getItemStack(key)); 
      itemConfig.setItemStackList(itemStackList);
      ItemConfig.getItemConfigMap().put(itemId, itemConfig);
    } 
    File messageFile = new File(plugin.getDataFolder(), "message.yml");
    YamlConfiguration msgYml = YamlConfiguration.loadConfiguration(messageFile);
    int x = yml.getInt("Message.x");
    int y = yml.getInt("Message.y");
    for (String key : msgYml.getKeys(false)) {
      String message = msgYml.getString(key).replace("&", "§");
      MessageConfig messageConfig = new MessageConfig();
      messageConfig.setId(key);
      messageConfig.setVexText(new VexText(x, y, Arrays.asList(new String[] { message })));
      MessageConfig.getVexTextMap().put(key, messageConfig);
    } 
    ClickableVexButtonConfig.setDefUrl(yml.getString("Button.defaultUrl"));
    ClickableVexButtonConfig.setCheckUrl(yml.getString("Button.checkedUrl"));
    ClickableVexButtonConfig.setNotCheckUrl(yml.getString("Button.unclickable"));
    ClickableVexButtonConfig.setButtonXshow(yml.getInt("Button.xshow"));
    ClickableVexButtonConfig.setButtonYshow(yml.getInt("Button.yshow"));
    for (String key : yml.getConfigurationSection("Button.buttonLocation").getKeys(false)) {
      int id = Integer.parseInt(key.replace("button", ""));
      ClickableVexButtonConfig clickableVexButtonConfig = new ClickableVexButtonConfig();
      clickableVexButtonConfig.setId(id);
      clickableVexButtonConfig.setX(yml.getInt("Button.buttonLocation." + key + ".x"));
      clickableVexButtonConfig.setY(yml.getInt("Button.buttonLocation." + key + ".y"));
      ClickableVexButtonConfig.getVexButtonConfigMap().put(Integer.valueOf(id), clickableVexButtonConfig);
    } 
    Date date = new Date();
    DAY = date.getDate();
    MONTH = date.getMonth() + 1;
  }
}
